; >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
;
;
;
;
;
;
;
; >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

Splashx		proto :dword,:dword,:dword,:dword,:dword,:dword,:dword
TopXY 			proto :dword,:dword

.code
ALIGN 4
start:
;----------------  CHECK IF ALREADY LOADED -----------------
; If MutexString matches the name of an existing named mutex object,
; this function returns ERROR_ALREADY_EXISTS.
    invoke CreateMutex,NULL,NULL,SADD("  GenericTestBed")
    invoke GetLastError           ; the program can be loaded only once.
.IF eax == ERROR_ALREADY_EXISTS   ; exit if already loaded.
    invoke MessageBox,0,SADD("Generic already running"),0,MB_OK
    invoke ExitProcess,0          ; is finished.
.ENDIF

    invoke GetModuleHandle, NULL
    mov hInstance, eax
    invoke GetCommandLine 
    mov CommandLine, eax

    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
    invoke ExitProcess,eax 

; ________________________________________________________________________
; ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
ALIGN 4
WinMain proc hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

 LOCAL wc   :WNDCLASSEX
 LOCAL msg  :MSG
 LOCAL Wtx  :DWORD
 LOCAL Wty  :DWORD
local Wwd:dword
local Wht:dword
Local icc  :INITCOMMONCONTROLSEX
local idx  :dword
local mii  :MENUITEMINFO 
LOCAL	lfnt:LOGFONT

	invoke	memfill, addr lfnt, sizeof lfnt, NULL
	mov		lfnt.lfHeight, -11
	mov		lfnt.lfWeight, FW_NORMAL ;FW_BOLD	
	invoke	szCatStr, addr lfnt.lfFaceName, offset szFontName
	invoke	CreateFontIndirect, addr lfnt
	mov		hFont, eax
	
					Mov icc.dwSize, sizeof INITCOMMONCONTROLSEX
					Mov icc.dwICC,ICC_WIN95_CLASSES or ICC_DATE_CLASSES or ICC_USEREX_CLASSES\
							 or ICC_INTERNET_CLASSES or ICC_PAGESCROLLER_CLASS or ICC_COOL_CLASSES
					Invoke InitCommonControlsEx, Addr icc

         mov wc.cbSize,sizeof WNDCLASSEX
         mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
         mov wc.lpfnWndProc,offset WndProc
         mov wc.cbClsExtra,NULL
         mov wc.cbWndExtra,NULL
         mov eax,hInst
         mov wc.hInstance,eax
         mov wc.hbrBackground,COLOR_BTNFACE+1
         mov wc.lpszMenuName,NULL
         mov wc.lpszClassName,CTXT("GENERIC")
         invoke LoadIcon,hInst,500
         mov wc.hIcon,eax
         invoke LoadCursor,NULL,IDC_ARROW
         mov wc.hCursor,eax
         mov wc.hIconSm,0

         invoke RegisterClassEx, addr wc

         mov Wwd, 700
         mov Wht, 560

         invoke GetSystemMetrics,SM_CXSCREEN     
         invoke TopXY,Wwd,eax
         mov Wtx, eax

         invoke GetSystemMetrics,SM_CYSCREEN
         invoke TopXY,Wht,eax
         mov Wty, eax

         invoke CreateWindowEx,0,SADD("GENERIC"),SADD("    Generic Test Bed"),
                              WS_OVERLAPPED or WS_SYSMENU or WS_MINIMIZEBOX,Wtx,Wty,Wwd,Wht,
                              NULL,NULL,hInst,NULL
         mov hWnd,eax

         invoke ShowWindow,hWnd, SW_SHOWNORMAL
         invoke UpdateWindow,hWnd

; ________________________________________________________________________
; ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

    StartLoop:
      invoke GetMessage,addr msg,NULL,0,0
      cmp eax,0 
      je ExitLoop   
      invoke TranslateMessage,addr msg
      invoke DispatchMessage,addr msg
      jmp StartLoop
    ExitLoop:
    mov eax,msg.wParam
      ret

WinMain endp

; >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ALIGN 4
TopXY proc wDim:DWORD, sDim:DWORD
    shr sDim, 1
    shr wDim, 1 
    mov eax, wDim 
    sub sDim, eax   
    mov eax,sDim
    ret
TopXY endp

; >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
